program Project15;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils,
  VCL.FlexCel.Core,
  FlexCel.XlsAdapter;

var
  xls: TExcelFile;
  Cell: TCellValue;
  Text1, Text2, Text3: string;
  Number, Price: double;
  SomeDate: TDateTime;
  Row, Col: integer;
begin
  xls := TXlsFile.Create(true);
  try
    xls.Open('..\..\test.xlsx');
    for Row := 2 to xls.RowCount do
    begin
      Cell := xls.GetCellValue(Row, 1);
      Text1 := Cell.ToString;
      if Text1 = '' then continue;


      Cell := xls.GetCellValue(Row, 2);
      Text2 := Cell.ToString;

      Cell := xls.GetCellValue(Row, 3);
      Text3 := Cell.ToString;

      Cell := xls.GetCellValue(Row, 4);
      if not Cell.IsNumber then raise Exception.Create('Column 4 must be a number');
      Number := Cell.AsNumber;

      Cell := xls.GetCellValue(Row, 5);
      if not Cell.IsNumber then raise Exception.Create('Column 5 must be a number');
      Price := Cell.AsNumber;

      Cell := xls.GetCellValue(Row, 6);
      if not Cell.IsNumber then raise Exception.Create('Column 6 must be a datetime');
      SomeDate := Cell.ToDateTime(xls.OptionsDates1904);

      WriteLn(Text1, ' | ', Text2, ' | ', Text3, ' | ', Number, ' | ', Price, ' | ', DateTimeToStr(SomeDate));

    end;

  finally
    xls.Free;
  end;

  Readln;
end.
